@import "reset";
@import "general";
@import "global";

// text-overflow: ellipsis;

/* <main.scss> */
// $colBlue: #457bb8;
$colBlue: #008CBA;
$colDarkBlue: darken($color: $colBlue, $amount: 10);
$colGray: #d3d3d3;

body {
    font-family: 'Montserrat', sans-serif;
    background-color: #eaebf0;
    user-select: none !important;
    outline: none !important;
}

.site {
    $border-radius: 0.3rem;
    transition: transform 0.125s cubic-bezier(0.37, 0, 0.63, 1);

    &.slide-right {
        transform: translateX(-100vw);
    }

    &.slide-left {
        transform: translateX(100vw);
    }

    &.test {
        display: grid;
        grid-template-columns: auto;
        grid-template-rows: auto;
        background-color: #e9ebf0;

        .devices {
            display: grid;
            place-items: stretch;
            place-content: center;
            grid-template-columns: repeat(4, 20rem);
            gap: 1rem;
            margin: 2rem 0;

            .device {
                display: grid;
                grid-template-columns: 1fr;
                grid-template-rows: 3rem auto auto;
                place-items: stretch;

                box-shadow: 0.1rem 0.1rem 1rem 0px rgba(0,0,0,0.05);
                background-color: #ffffff;

                @include tablet-large {
                    border-radius: $border-radius;
                }

                > .label {
                    border-top-left-radius: $border-radius;
                    border-top-right-radius: $border-radius;
                    line-height: 3rem;
                    // padding: 0 0.8rem;
                    text-align: center;
                    background-color: $colBlue;
                    color: #ffffff;
                    font-weight: 600;
                }
            }
        }
    }

    &.devices-list {
        display: block;
        width: 100%;

        @include tablet-large {
            max-width: $TABLET-LARGE-MIN-WIDTH;
            margin: 0 auto;
            padding: 3rem 0;
        }

        > .room-title {
            height: 3rem;
            line-height: 3rem;
            text-align: center;
            padding: 0 1rem;
            overflow: hidden;
            // color: #3d3d3d;
            color: $colBlue;
            font-weight: bold;
            margin: 0;
            font-size: 1.2rem;

            @include tablet-large {
                margin: 1rem 0 0 0;
                border-radius: $border-radius;
                background-color: rgba(255, 255, 255, 0.3);
            }
        }

        > .device {
            display: grid;
            grid-template-columns: 3rem 1fr 3rem;
            grid-template-rows: 3rem;
            place-items: stretch;
            font-size: 1rem;

            @include tablet-large {
                border-radius: $border-radius;
            }

            background-color: #ffffff;
            cursor: pointer;

            &:hover {
                background-color: #f8f9fc;
            }

            &:not(:first-child) {
                margin-top: 3px;
            }

            > .icon, .arrow {
                text-align: center;
                line-height: 3rem;
                // background-color: $colBlue;
                color: $colBlue;
            }

            > .label {
                text-align: left;
                // padding: 0 1rem;
                line-height: 3rem;
                overflow: hidden;
                text-overflow: ellipsis;
                color: #3f3f3f;
            }
        }
    }

    &.device {
        display: block;
        width: 100%;
        padding-bottom: 3px;

        @include tablet-large {
            max-width: $TABLET-LARGE-MIN-WIDTH;
            margin: 0 auto;
            padding: 3rem 0;
        }

        > .top-bar {
            display: grid;
            grid-template-columns: 3rem 1fr;
            grid-template-rows: 3rem;
            place-items: stretch;
            width: 100%;
            overflow: hidden;
            font-weight: bold;

            background-color: #ffffff;
            border-bottom: 3px solid $colBlue;

            @include tablet-large {
                // padding-top: 1rem;
                border-radius: $border-radius;
                border-width: 5px;
            }

            > .icon {
                text-align: center;
                line-height: 3rem;
                background-color: $colBlue;
                color: #ffffff;
                font-size: 1.2rem;
                cursor: pointer;

                @include tablet-large {
                    border-top-left-radius: $border-radius;
                }
            }

            > .title {
                padding: 0 1rem;
                text-align: center;
                overflow: hidden;
                line-height: 3rem;
                color: $colBlue;
                font-size: 1.2rem;
                font-weight: bold;
            }
        }

        > .device-icon {
            padding: 1rem 0;
            text-align: center;
            color: $colBlue;
            font-size: 5rem;
            // margin-top: -0.5rem;

            @include tablet-large {
                background-color: rgba(255, 255, 255, 0.3);
                border-bottom-left-radius: 0.3rem;
                border-bottom-right-radius: 0.3rem;
            }
        }

        > .action {
            display: grid;
            grid-template-columns: 3rem 1fr 3rem;
            // grid-template-rows: 3rem;
            grid-template-rows: repeat(auto-fill, 3rem);
            place-items: stretch;
            font-size: 1rem;

            @include tablet-large {
                border-radius: $border-radius;
            }

            background-color: #ffffff;

            &:hover {
                background-color: #f8f9fc;
            }

            &:not(:first-child) {
                margin-top: 3px;
            }

            &.with-arguments {
                > .send {
                    @include tablet-large {
                        border-bottom-right-radius: 0;
                        border-bottom-left-radius: $border-radius;
                    }
                }
            }

            > .icon {
                text-align: center;
                line-height: 3rem;
                // background-color: $colBlue;
                color: $colBlue;
            }

            > .send {
                text-align: center;
                line-height: 3rem;
                color: #ffffff;
                background-color: $colBlue;
                cursor: pointer;
                transition: background-color 100ms cubic-bezier(0.37, 0, 0.63, 1);

                @include tablet-large {
                    border-top-right-radius: $border-radius;
                    border-bottom-right-radius: $border-radius;
                }

                &.active {
                    background-color: $colDarkBlue;
                }
            }

            > .label {
                text-align: left;
                // padding: 0 1rem;
                line-height: 3rem;
                overflow: hidden;
                text-overflow: ellipsis;
                color: #3f3f3f;
            }

            > .arguments {
                width: 100%;
                margin: 1rem;
                grid-column: 1 / span 2;

                td {
                    padding: 0.3rem 0.5rem;
                    vertical-align: middle;
                    white-space: nowrap;
                }

                input[type="text"], input[type="number"] {
                    $animDuration: 200ms;

                    padding: 0.3rem;
                    border: none;
                    border-bottom: 2px solid $colGray;
                    width: 100%;
                    transition: border-color $animDuration cubic-bezier(0.37, 0, 0.63, 1);
                    color: $colBlue;

                    &:focus {
                        outline: none;
                        border-bottom: 2px solid $colBlue;
                    }

                    @include tablet-large {
                        border-top-left-radius: $border-radius;
                        border-top-right-radius: $border-radius;
                    }
                }

                input[type="checkbox"] {
                    $animDuration: 200ms;

                    appearance: none;
                    background-color: #ffffff;
                    border: none;
                    border-bottom: 2px solid $colGray;
                    padding: 1rem;
                    margin-bottom: -0.5rem;
                    display: inline-block;
                    position: relative;
                    outline: none;
                    transition: border-color $animDuration cubic-bezier(0.37, 0, 0.63, 1);

                    &:after {
                        transition: opacity $animDuration cubic-bezier(0.37, 0, 0.63, 1);
                        content: '\2714';
                        font-size: 1.3rem;
                        position: absolute;
                        top: 0.1rem;
                        left: 0.5rem;
                        color: $colBlue;
                        opacity: 0.1;
                    }

                    @include tablet-large {
                        border-radius: $border-radius;
                    }

                    &:checked {
                        border-color: $colBlue;

                        &:after {
                            opacity: 1;
                        }
                    }
                }
            }
        }

        > .port {
            display: grid;
            grid-template-columns: 3rem 1fr 6rem;
            grid-template-rows: 3rem;
            place-items: stretch;
            font-size: 1rem;

            @include tablet-large {
                border-radius: $border-radius;
            }

            background-color: #ffffff;

            &:hover {
                background-color: #f8f9fc;
            }

            &:not(:first-child) {
                margin-top: 3px;
            }

            > .icon {
                text-align: center;
                line-height: 3rem;
                // background-color: $colBlue;
                color: $colBlue;
            }

            > .label {
                text-align: left;
                // padding: 0 1rem;
                line-height: 3rem;
                overflow: hidden;
                text-overflow: ellipsis;
                color: #3f3f3f;
            }

            > .controls {
                $animDuration: 200ms;

                text-align: center;
                line-height: 3rem;
                color: $colBlue;
                display: grid;
                align-content: center;
                justify-content: right;
                padding-right: 0.5rem;

                .slider-switch {
                    width: 4rem;
                    height: 2.1rem;

                    position: relative;
                    display: inline-block;
                    margin: 0;

                    input[type="checkbox"] {
                        opacity: 0;
                        width: 0;
                        height: 0;
                    }

                    .slide-button {
                        position: absolute;
                        cursor: pointer;
                        top: 0;
                        left: 0;
                        right: 0;
                        bottom: 0;
                        background-color: $colGray;
                        transition: transform $animDuration cubic-bezier(0.37, 0, 0.63, 1);
                        border-radius: 1.5rem;

                        &:before {
                            $size: 1.5rem;
                            $offs: 0.3rem;
                            position: absolute;
                            content: "";
                            height: $size;
                            width: $size;
                            left: $offs*1.1;
                            bottom: $offs;
                            background-color: white;
                            transition: transform $animDuration cubic-bezier(0.37, 0, 0.63, 1);
                            border-radius: 1.5rem;
                        }
                    }

                    input[type="checkbox"]:checked + .slide-button {
                        background-color: $colBlue;
                    }

                    input[type="checkbox"]:focus + .slide-button {
                        box-shadow: 0 0 1px $colBlue;
                    }

                    input[type="checkbox"]:checked + .slide-button:before {
                        transform: translateX(1.8rem);
                    }
                }

                .slider-range {
                    $animDuration: 200ms;

                    appearance: none;
                    width: 4rem;
                    height: 0.8rem;
                    border-radius: 0.3rem;
                    background: $colGray;
                    outline: none;
                    // opacity: 0.7;
                    transition: opacity $animDuration cubic-bezier(0.37, 0, 0.63, 1);

                    &::-webkit-slider-thumb {
                        appearance: none;
                        width: 1.5rem;
                        height: 1.5rem;
                        border-radius: 50%;
                        background: $colBlue;
                        border: none;
                        cursor: pointer;
                    }

                    &::-moz-range-thumb {
                        width: 1.5rem;
                        height: 1.5rem;
                        border-radius: 50%;
                        background: $colBlue;
                        border: none;
                        cursor: pointer;
                    }
                }

                .indicator {
                    display: inline-block;
                    margin-right: 1.2rem;
                    width: 1.5rem;
                    height: 1.5rem;
                    background-color: $colGray;
                    border-radius: 50%;

                    &.active {
                        background-color: $colBlue;
                    }
                }

                .progress-bar {
                    display: block;
                    width: 4rem;
                    height: 0.81rem;
                    background-color: $colGray;
                    border-radius: $border-radius;
                    text-align: left;
                    padding: 0;

                    .status {
                        display: block;
                        width: 0%;
                        height: 100%;
                        background-color: $colBlue;
                        border-radius: $border-radius;
                    }
                }
            }
        }

        > .splitter {
            display: block;
            height: 0.5rem;
            width: 100%;
            opacity: 0;

            @include tablet-large {
                height: 1rem;
            }
        }
    }
}

/* </main.scss> */